Ticket #34016

LP使用譜面の読み込み機能

Open Date: 2014-07-09 00:18 Last Update: 2016-08-23 01:45

Reporter:
Owner:
Status:
Closed
Component:
MileStone:
Priority:
5 - Medium
Severity:
5 - Medium
Resolution:
Accepted
File:
None
Vote
Score: 0
No votes
0.0% (0/0)
0.0% (0/0)

Details

昨今XG系の譜面が多くなってきたが、それをこちらの本体で読み込むと、LPやLBDの情報が失われてしまう。

そこで、現状の本体レーン構成を維持しつつ(もしくは違和感のない形で拡張レーンを表現することで)、違和感のない形でXG譜面を読み込めるようにしたい。

XG対応レーンから、XG非対応レーンに振り分けるルールは、まずは以下のように定める。これで問題ないかどうかは、試作して検証する。

  • LPとLBDの両方が使われている場合は、
    • LBDはBDに割り当て
    • LPは、HO(foot splash)に割り当て。あるいは、HO(foot splash)とHC(close)のいずれかに割り当てる。BPMから8分音符の長さを計算し、それより長いかどうかでHO/HCの仕分けを決定。
    • チップ音にサウンドファイルが割り当てられていない場合は、HCに割り当て
  • LPのみ使われている場合は、LPを、BD, HO, HCに割り当てる必要があるが・・
    • BDへの割り当ては、BDレーンで同じ音を使っているかどうかで決定
    • HO, HCへの割り当ては、(BDの可能性を除いた後) HOにアサイン、あるいはチップの長さを見てHC/HOにアサイン
    • チップ音にサウンドファイルが割り当てられていない場合は、HCに割り当て
  • LBDのみ使われている場合は
    • そのままBDに割り当て

Ticket History (3/6 Histories)

2014-07-09 00:18 Updated by: yyagi
  • New Ticket "LP使用譜面の読み込み機能" created
2016-03-20 14:00 Updated by: yyagi
  • Details Updated
2016-03-20 14:10 Updated by: yyagi
Comment

備忘録: チップにアサインされたレーンを変更することにより、チップの重複が発生する可能性がある。その場合の動作仕様について要検討。

2016-08-09 00:50 Updated by: yyagi
Comment

rev1028で機能追加しました。https://osdn.jp/users/yyagi/pf/DTXMania_TestBuilds/files/DTXMania/DTXManiaGR_105_LPreassign.zip

LPやLBDを使った譜面の手持ちがほとんどないため、適当にテストいただけると助かります。

基本的には、私の提案内容の通りに実装しましたが、以下を変更しています。

  • HC/HOの区別を、8分音符の長さを基準にして分ける → 4分音符基準に変更。フットペダルの音長は、8分音符では短すぎた。
  • HOが全く使われていない譜面の場合は、HOに割り振るような状況でもHCに割り振るようにした。(この条件でHOのままだと違和感ありまくりだった・・)

制限:

  • score.iniに、譜面のレーン数(というか使用レーンの種類)の情報を出力していない。

実際に試してみた感想:

  • いわゆるdkdk譜面がちゃんとBDレーン1つの中に出てくるのはいい感じ
  • Foot Pedalのチップがほしい・・・HC/HOに持ってくると違和感がある・・・(足で出す音を手のレーンに持ってくるのは変な感じがする・・・)
2016-08-09 01:17 Updated by: yyagi
Comment

すみません、制限を1つ追加します。

  • チップのレーン変更に伴う、チップのダブリについては、まだ未考慮。
2016-08-23 01:45 Updated by: yyagi
  • Resolution Update from None to Accepted
  • Status Update from Open to Closed
  • Ticket Close date is changed to 2016-08-23 01:45
Comment

Release106で、ここまでで実装した機能をそのままリリースしました。

以下の課題が残っていますが、いったんクローズします。必要に応じてチケットを再オープン願います。

  • チップのレーン変更に伴う、チップのダブリについて、考慮していない。
  • チップ音の長さを、単純にwavやoggファイルの長さで判断している。そのため、無音が続くチップ音が使われていると、正しい判定がなされない。

Attachment File List

No attachments

Edit

You are not logged in. I you are not logged in, your comment will be treated as an anonymous post. » Login